#ifndef StHbtVertexMultSphAnalysis_hh
#define StHbtVertexMultSphAnalysis_hh

#include "StHbtMaker/Infrastructure/StHbtAnalysis.h"        // base analysis class
#include <limits.h>

class StHbtVertexMultSphAnalysis : public StHbtAnalysis {

 public:
  StHbtVertexMultSphAnalysis(unsigned int binsVertex=10, double minVertex=-100., double maxVertex=100.,
                             unsigned int binsMult=10,   double minMult=-1.e9,   double maxMult=1.e9,
                             unsigned int binsSph=10,    float  minSph=0.,       float  maxSph=1.);
  StHbtVertexMultSphAnalysis(const StHbtVertexMultSphAnalysis &);  // copy constructor
  virtual void ProcessEvent(const StHbtEvent *);
  virtual ~StHbtVertexMultSphAnalysis();
  virtual StHbtString Report();       //! returns reports of all cuts applied and correlation functions being done
  virtual unsigned int OverflowVertexZ() { return mOverFlowVertexZ;}
  virtual unsigned int UnderflowVertexZ() { return mUnderFlowVertexZ;}
  virtual unsigned int OverflowMult() { return mOverFlowMult;}
  virtual unsigned int UnderflowMult() { return mUnderFlowMult;}
  virtual unsigned int OverflowSph() { return mOverFlowSph;}
  virtual unsigned int UnderflowSph() { return mUnderFlowSph;}
 protected:
  double mVertexZ[2];
  unsigned int mVertexZBins;
  unsigned int mOverFlowVertexZ;
  unsigned int mUnderFlowVertexZ;
  double mMult[2];
  unsigned int mMultBins;
  unsigned int mOverFlowMult;
  unsigned int mUnderFlowMult;
  float mSph[2];
  unsigned int mSphBins;
  unsigned int mOverFlowSph;
  unsigned int mUnderFlowSph;

#ifdef __ROOT__
  ClassDef(StHbtVertexMultSphAnalysis, 0)
#endif

};

#endif
