#include "StPicoDstTriggerQA.h"


ClassImp(StPicoDstTriggerQA)


StPicoDstTriggerQA::StPicoDstTriggerQA(StPicoDstMaker *picoMaker, const char *outFilePath)
{
  std::cout << "Constructor" << std::endl;
  mPicoMaker = picoMaker;
  mOutFilePath = outFilePath;
}



StPicoDstTriggerQA::~StPicoDstTriggerQA()
{
  //
  // NO-OP
  //
}



Int_t StPicoDstTriggerQA::Init()
{
  std::cout << "Init" << std::endl;
  mOutFile = new TFile(mOutFilePath, "RECREATE");

  if (!mOutFile)
    std::cout << "Can't recreate file " << mOutFilePath << std::endl;


  //
  // Event histograms
  //
  hTrigger = new TH1D("hTrigger", ";trigger bit;#", 32, 0., 31.);

  return StMaker::Init();
}


void StPicoDstTriggerQA::Clear(Option_t *option) 
{
  StMaker::Clear();
}


Int_t StPicoDstTriggerQA::Make()
{
  nEventsProc++;

  StPicoDst *picoDst = mPicoMaker->picoDst();
  if (!picoDst)
  {
    std::cout << "can't obtain StPicoDst" << std::endl;
    return kStOk;
  }

  StPicoEvent *picoEvent = picoDst->event();
  if (!picoEvent)
  {
    std::cout << "can't obtain StPicoEvent" << std::endl;
    return kStOk;
  }

  unsigned int trig = (unsigned int)picoEvent->triggerWord();
  for (int iBit = 0; iBit < 31; iBit++)
  {
    if ((1 << iBit) & trig)
      hTrigger->Fill(iBit);
  }

  return kStOk;
}


Int_t StPicoDstTriggerQA::Finish()
{
  std::cout << "Finish!" << std::cout;
  mOutFile->cd();
  mOutFile->Write();
  mOutFile->Close();

  return kStOk;
}
