/****************************************/
/***                                  ***/
/***    StPicoDstTriggerQA            ***/
/***  VERSION: 1.0                    ***/
/***   AUTHOR: Nikita Ermakov         ***/
/***     DATE:                        ***/
/***   E-MAIL: coffe92@gmail.com      ***/
/***                                  ***/
/****************************************/

#ifndef STPICODSTTRIGGERQA

#include "StPicoDst.h"
#include "StPicoDstMaker.h"
#include <stdio.h>
#include "TH2F.h"
#include "TH1F.h"
#include "TProfile.h"
#include "StPicoEvent.h"
#include "StPicoTrack.h"
#include "StPicoBTofPidTraits.h"
#include "StPhysicalHelixD.hh"



class StPicoDst;
class StPicoEvent;
class StPicoTrack;



class StPicoDstTriggerQA : public StMaker 
{
 public:
  StPicoDstTriggerQA(StPicoDstMaker *picoMaker, const char *outFilePath);
  ~StPicoDstTriggerQA();

  //
  // Chain methods
  //
  void  Clear(Option_t *option = "");
  Int_t Init();
  Int_t Make();
  Int_t Finish();
 private:
  const char     *mOutFilePath;
  TFile          *mOutFile;
  TChain         *mChain;
  TTree          *mTree;
  StPicoDstMaker *mPicoMaker;

  unsigned int nEvents;
  unsigned int nEventsProc;

  //
  // Event histograms
  //
  TH1D *hTrigger;

  ClassDef(StPicoDstTriggerQA, 1)
};

#endif
