#include "SuperStarHijing.h"


ClassImp(SuperStarHijing)



SuperStarHijing::SuperStarHijing(const Char_t *name) : StarHijing(name)
{
    /* NO-OP */
}

Int_t SuperStarHijing::Init()
{
    mEvent = new StarGenAAEvent();

    // Number of spectators
    // Initialized per event
    for ( Int_t i=0; i<2; i++ ){
        mNumberOfSpectatorProtons[i]=0;
        mNumberOfSpectatorNeutrons[i]=0;
    }

    /**
     *
     *  These particles will be decayed by geant instead of hijing
     *
     **/ 
#define STABLE(x) ludat3().mdcy( Lucomp( x ), 1 ) = 0
    STABLE( 111 );
    STABLE( 221 );
    STABLE( 3122 );
    STABLE( 3212 );
    STABLE( 3112 );
    STABLE( 3222 );
    STABLE( 3312 );
    STABLE( 3322 );
    STABLE( 3334 );
#undef STABLE





    /*
      ludat3().mdcy(102,1)=0; // PI0 111
      ludat3().mdcy(109,1)=0; // ETA 221
      ludat3().mdcy(164,1)=0; // LAMBDA0 3122
      ludat3().mdcy(167,1)=0; // SIGMA0 3212
      ludat3().mdcy(162,1)=0; // SIGMA- 3112
      ludat3().mdcy(169,1)=0; // SIGMA+ 3222
      ludat3().mdcy(172,1)=0; // Xi- 3312
      ludat3().mdcy(174,1)=0; // Xi0 3322
      ludat3().mdcy(176,1)=0; // OMEGA- 3334
    */
    // Double check indexing here
    /*
      ludat3().mdcy(106,1)=0; // PI+ 211   (not decayed anyhow)
      ludat3().mdcy(112,1)=1; // K_SHORT 310   ... decay these ...
      ludat3().mdcy(105,1)=1; // K_LONG 130
      ludat3().mdcy(116,1)=0; // K+ 321
    */

 
    //
    // Check the frame.  Only CMS is supported at this time
    //
    if (!( mFrame == "CMS" || mFrame =="FIXT"))
    {
        cout << "StarHijing: Only CMS / FIXT frame supported for now.  Kill me now." << endl;
    }

    ////////////////////////////////////
    // Initialize the hijing
    ///////////////////////////////////
  
    // Map typical species run at RHIC
    map<TString,Int_t> A, Z;  map<TString,string> type;
    A["p"]  =1;    Z["p"]  =1;   type["p"]  ="P       "; 
    A["n"]  =1;    Z["n"]  =0;   type["n"]  ="N       ";
    A["d"]  =2;    Z["d"]  =1;   type["d"]  ="A       ";
    A["He3"]=3;    Z["He3"]=2;   type["He3"]="A       ";


    A["Au"]=197;  Z["Au"]=79;  type["Au"]="A       ";
    A["Pb"]=207;  Z["Pb"]=82;  type["Pb"]="A       ";  
    A["Cu"]=63;   Z["Cu"]=29;  type["Cu"]="A       ";
    A["U"] =238;  Z["U"]=92;   type["U"] ="A       ";
    A["Al"]=27;   Z["Al"]=13;  type["Al"]="A       ";

    A["proton"]   =1;    Z["proton"]   =1;   type["proton"]   ="P       "; // important to map size of type onto character*8
    A["neutron"]  =1;    Z["neutron"]  =0;   type["neutron"]  ="N       ";
    A["deuteron"] =2;    Z["deuteron"] =1;   type["deuteron"] ="A       ";

    hiparnt().ihpr2(12) = 0; // 0=particle decays on 1=off

    string frame = mFrame.Data();
    if(frame =="FIXT") frame="LAB";

    float  roots = TMath::Abs( mRootS );
    Hijset( roots, frame, type[mBlue], type[mYell], A[mBlue], Z[mBlue], A[mYell], Z[mYell] );

    mNumberOfBeamProtons[0]=Z[mBlue];
    mNumberOfBeamProtons[1]=Z[mYell];
    mNumberOfBeamNeutrons[0]=A[mBlue]-mNumberOfBeamProtons[0];
    mNumberOfBeamNeutrons[1]=A[mYell]-mNumberOfBeamProtons[1];

    //
    // Grab the computed maximum impact parameter for the collision and report it.  Test
    // against user's impact parameter and report if it's too large, and truncate.
    //
    Float_t bmax = hiparnt().hipr1(34)+hiparnt().hipr1(35);
    if ( mImpactMax < 0 )
    {
        mImpactMax = bmax;
    }
    cout << Form("HIJING impact parametr allowed range is 0 .. %f fm", bmax) << endl;
    if ( mImpactMax > bmax )
    {
        cout << Form("     >>> user's value too large, truncating to %f fm <<< ", bmax) << endl;
        mImpactMax = bmax;
    }
    cout <<      "------------------------------------------------------------------------------" << endl;
    cout <<      "------------------------------------------------------------------------------" << endl;
    cout << Form("HIJING events will be generated with impact parameter %f .. %f fm", mImpactMin, mImpactMax ) << endl;
    cout <<      "------------------------------------------------------------------------------" << endl;
    cout <<      "------------------------------------------------------------------------------" << endl;
    //
    // PDG id for heavy ions
    //
    //if ( mBlue != "p" && mBlue != "n" )  mBlueId = 10 * A[mBlue] + 10000 * Z[mBlue] + 1000000000;
    //if ( mYell != "p" && mYell != "n" )  mBlueId = 10 * A[mYell] + 10000 * Z[mYell] + 1000000000;

    //
    // Keep all information for all particles, even those which decay
    //
    hiparnt().ihpr2(21)=1;
    hiparnt().ihpr2(10)=1; // show error msgs

    return StMaker::Init();
}
